
#cs

TXML word count
Samuel Murray, 2013

1. Delete everything between <revisions> and </revisions>
2a. Split by <target and add <target again
2b. Split by </target and add </target again
3. If it contains <target> then the target is a 0% match
4. Else, if it contains golden="true" then its a golden match
5. Else, if it contains score="100" then it is a 100% match
6. Else, split by score=" and again by " to determine score

Then place score in column 1, full target in column 2, and export

1. Delete <target*>
2. Delete </target>
3. Replace <ut*</ut> with [x]

#ce

; MsgBox (0, "Dead simple TXML word count", "For usage instructions, read the README file.", 0)

If $CmdLine[0] = 0 Then
$fileopendialog = FileOpenDialog ("Select translated TXML file", @ScriptDir,  "TXML (*.txml)|Other (*.*)")
ElseIf $CmdLine[0] = 1 Then
$fileopendialog = $CmdLine[1]
EndIf

$fileopen = FileOpen ($fileopendialog, 128)
$fileread = FileRead ($fileopen)

$outputstring = ""

$step0 = StringReplace ($fileread, @TAB, "[TAB]")
$step0 = StringReplace ($step0, @CRLF, "[CRLF]")

$step1 = StringRegExpReplace ($step0, "<revisions>(?s).+?</revisions>", "")

$step2 = StringSplit ($step1, "<target", 1)
For $i = 2 to $step2[0]
$step2[$i] = "<target" & $step2[$i]
Next

For $j = 1 to $step2[0]

If StringInStr ($step2[$j], "<?xml") Then
ContinueLoop
EndIf

$step3 = StringSplit ($step2[$j], "</target>", 1)
$step3[1] = $step3[1] & "</target>"

If StringRegExp ($step3[1], "<target>") Then ; then it's a 0% match
$outputstring = $outputstring & "0" & @TAB & $step3[1] & @CRLF

ElseIf StringRegExp ($step3[1], '<target[^>]+?golden="true"(?s).*') Then
$outputstring = $outputstring & "101" & @TAB & $step3[1] & @CRLF

ElseIf StringRegExp ($step3[1], '<target[^>]+?score="100"(?s).*') Then
$outputstring = $outputstring & "100" & @TAB & $step3[1] & @CRLF

ElseIf StringRegExp ($step3[1], '<target[^>]+?score="0"(?s).*') Then
$outputstring = $outputstring & "0" & @TAB & $step3[1] & @CRLF

ElseIf StringRegExp ($step3[1], '(<target[^>]+?score=")(\d\d)("(?s).*)') Then
$scorenumber = StringRegExpReplace ($step3[1], '(<target[^>]+?score=")(\d\d)("(?s).*)', "$2")
$outputstring = $outputstring & $scorenumber & @TAB & $step3[1] & @CRLF

Else

$outputstring = $outputstring & "ERROR" & @TAB & $step3[1] & @CRLF

EndIf

Next

; quickfix

$outputstring = StringReplace ($outputstring, "<target>", "")
$outputstring = StringReplace ($outputstring, "</target>", "")
$outputstring = StringRegExpReplace ($outputstring, '<target(?s).+?>', "")

$outputstring = StringRegExpReplace ($outputstring, '<ut.+?</ut>', " [UT] ")


$writefile = FileOpen ($fileopendialog & "_wordcount.txt", 130)
FileWrite ($writefile, $outputstring)

